//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RotateLabel.h"
//---------------------------------------------------------------------------
__fastcall TRotateLabel::TRotateLabel(TComponent* Owner)
	: TCustomControl(Owner)
{
   FAngle = 0;
   FCaption = Name;
}

void __fastcall TRotateLabel::Paint()
{
   SetTextAngle(FAngle);
   Canvas->Font = Font;
   Canvas->Brush->Color = Color;

   int nXPos = Width / 2 - ( Canvas->TextWidth(FCaption) / 2 );
   int nYPos = Height / 2 - ( Canvas->TextHeight(FCaption) / 2 );

   if ( FAngle == 90 )
   {
	   nXPos = Width / 2 - ( Canvas->TextHeight(FCaption) / 2 );
	   nYPos = Height / 2 + ( Canvas->TextWidth(FCaption) / 2 );
   }

   //   
   Canvas->TextOut ( nXPos, nYPos, FCaption );
}

void __fastcall TRotateLabel::SetTextAngle( int d )
{
  LOGFONT LogRec;
  GetObject(Font->Handle,sizeof(LogRec),&LogRec);

  if ( LogRec.lfEscapement != d * 10.0 || Font->Handle != Canvas->Font->Handle )
  {
	  LogRec.lfEscapement = (double)d * 10.0;

	  Font->Handle = CreateFontIndirect(&LogRec);
  }
}

int __fastcall TRotateLabel::GetAngle()
{
   return FAngle;
}

void __fastcall TRotateLabel::SetAngle(int NewVal)
{
  FAngle = NewVal;
  //  
  SetTextAngle ( FAngle );
  //  
  Repaint();
}

void __fastcall TRotateLabel::SetCaption(AnsiString strCaption)
{
   FCaption = strCaption;
   Repaint();
}


//---------------------------------------------------------------------------
namespace Rotatelabel
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TRotateLabel)};
		RegisterComponents("Samples", classes, 0);
	}
}
//---------------------------------------------------------------------------
